Index: /trunk/src/org/apollo/util/PopupReaper.java
===================================================================
--- /trunk/src/org/apollo/util/PopupReaper.java	(revision 1101)
+++ /trunk/src/org/apollo/util/PopupReaper.java	(revision 1102)
@@ -13,5 +13,5 @@
 import javax.swing.SwingUtilities;
 
-import org.expeditee.gui.MouseEventRouter;
+import org.expeditee.gio.swing.MouseEventRouter;
 import org.expeditee.gui.Popup;
 import org.expeditee.gui.PopupManager;
@@ -19,11 +19,11 @@
 
 /**
- * Yet another daemon .. whos job is to hide popups after their lifetimes have passed
+ * Yet another daemon .. whose job is to hide popups after their lifetimes have passed
  * 
  * @author Brook Novak
  */
 
-public class PopupReaper {
-	
+public class PopupReaper
+{
 	private Map<Popup, TemporaryPopup> tempPopups = new HashMap<Popup, TemporaryPopup>();// SHARED RESOURCE - the locker
 
@@ -31,7 +31,11 @@
 	
 	private static PopupReaper instance = new PopupReaper();
-	private PopupReaper() {
-	}
-	public  static PopupReaper getInstance() {
+	
+	private PopupReaper()
+	{
+	}
+	
+	public  static PopupReaper getInstance()
+	{
 		return instance;
 	}
@@ -62,5 +66,6 @@
 	 * 
 	 */
-	public void initPopupLifetime(Popup p, PopupAnimator hideAnimation, int lifetime) {
+	public void initPopupLifetime(Popup p, PopupAnimator hideAnimation, int lifetime)
+	{
 		if (p == null) throw new NullPointerException("p");
 		if (lifetime < 0) throw new IllegalArgumentException("lifetime < 0");
@@ -87,9 +92,5 @@
 				reaper.interrupt();
 			}
-			
-
-			
-		}
-		
+		}
 	}
 	
@@ -115,5 +116,6 @@
 	 * 
 	 */
-	public boolean revivePopup(Popup p, int lifetime) {
+	public boolean revivePopup(Popup p, int lifetime)
+	{
 		if (p == null) throw new NullPointerException("p");
 		if (lifetime < 0) throw new IllegalArgumentException("lifetime < 0");
@@ -134,7 +136,8 @@
 
 	
-	private class ReapDaemon extends Thread {
-		
-		ReapDaemon() {
+	private class ReapDaemon extends Thread
+	{
+		ReapDaemon()
+		{
 			super("Popup Reaper");
 			super.setPriority(Thread.MIN_PRIORITY);
@@ -142,6 +145,6 @@
 		}
 	
-		public void run() {
-			
+		public void run()
+		{
 			while (true) {
 			
@@ -166,6 +169,6 @@
 		 * 		A Positive wait time, or a negative for nothing to to wait on.
 		 */
-		private long reap() {
-
+		private long reap()
+		{
 			Collection<TemporaryPopup> snapshot;
 			
@@ -226,10 +229,11 @@
 	 *
 	 */
-	private class DoHide implements Runnable {
-		
+	private class DoHide implements Runnable
+	{
 		private TemporaryPopup tempPopup;
 		public boolean didHide = false;
 		
-		public DoHide(TemporaryPopup tempPopup) {
+		public DoHide(TemporaryPopup tempPopup)
+		{
 			this.tempPopup = tempPopup;
 		}
@@ -244,5 +248,6 @@
 		 * 		True if screenPoint is over c.
 		 */
-		private boolean isPointInComponant(Component c, Point screenPoint) {
+		private boolean isPointInComponant(Component c, Point screenPoint)
+		{
 			assert(c != null);
 			assert(screenPoint != null);
@@ -257,17 +262,15 @@
 		}
 	
-		public void run() {
+		public void run()
+		{
 			assert(tempPopup != null);
 			
 			MouseEvent me = MouseEventRouter.getCurrentMouseEvent();
 			if (me != null) {
-				
-				if (isPointInComponant(tempPopup.popup, me.getLocationOnScreen()))
-					return;
+				if (isPointInComponant(tempPopup.popup, me.getLocationOnScreen())) return;
 				
 				Component invoker = PopupManager.getInstance().getInvoker(tempPopup.popup);
-				if (invoker != null && isPointInComponant(invoker, me.getLocationOnScreen()))
-					return;
-				
+				
+				if (invoker != null && isPointInComponant(invoker, me.getLocationOnScreen())) return;
 			}
 
@@ -289,6 +292,6 @@
 	 *
 	 */
-	private class TemporaryPopup implements Comparable {
-
+	private class TemporaryPopup implements Comparable<TemporaryPopup>
+	{
 		private Popup popup;
 		private PopupAnimator hideAnim;
@@ -310,5 +313,6 @@
 		 *
 		 */
-		public TemporaryPopup(Popup popup, PopupAnimator anim, int lifetime) {
+		public TemporaryPopup(Popup popup, PopupAnimator anim, int lifetime)
+		{
 			assert(popup != null);
 			assert(lifetime >= 0);
@@ -320,5 +324,6 @@
 		}
 
-		public void setNewLifetime(int lifetime) {
+		public void setNewLifetime(int lifetime)
+		{
 			assert(lifetime >= 0);
 			this.lifetime = lifetime;
@@ -326,9 +331,11 @@
 		}
 		
-		public void resetLifetime() {
+		public void resetLifetime()
+		{
 			setNewLifetime(lifetime);
 		}
 		
-		public long getDelay() {
+		public long getDelay()
+		{
 			return destructionTime - System.currentTimeMillis();
 		}
@@ -337,13 +344,11 @@
 		 * {@inheritDoc}
 		 */
-		public int compareTo(Object o) {
-			
-			long dt2 = ((TemporaryPopup)o).destructionTime;
-			
-			if (destructionTime < dt2)
-		         return -1;
-			
-		      if (destructionTime > dt2)
-		         return 1;
+		public int compareTo(TemporaryPopup o)
+		{
+			long dt2 = o.destructionTime;
+			
+			if (destructionTime < dt2) return -1;
+			
+		    if (destructionTime > dt2) return 1;
 		      
 			return 0;
Index: /trunk/src/org/apollo/util/ProbeDaemon.java
===================================================================
--- /trunk/src/org/apollo/util/ProbeDaemon.java	(revision 1101)
+++ /trunk/src/org/apollo/util/ProbeDaemon.java	(revision 1102)
@@ -7,5 +7,5 @@
 import org.apollo.audio.util.Timeline;
 import org.apollo.gui.FrameLayoutDaemon;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 
 public class ProbeDaemon extends Thread {
@@ -46,5 +46,5 @@
 			String timeline = "none";
 			Timeline tl = FrameLayoutDaemon.getInstance().getLastComputedTimeline();
-			if (tl != null && DisplayIO.getCurrentFrame() == FrameLayoutDaemon.getInstance().getTimelineOwner()) {
+			if (tl != null && DisplayController.getCurrentFrame() == FrameLayoutDaemon.getInstance().getTimelineOwner()) {
 				timeline = tl.toString();
 			}
Index: /trunk/src/org/apollo/util/TextItemSearchResult.java
===================================================================
--- /trunk/src/org/apollo/util/TextItemSearchResult.java	(revision 1101)
+++ /trunk/src/org/apollo/util/TextItemSearchResult.java	(revision 1102)
@@ -1,6 +1,7 @@
 package org.apollo.util;
 
-import java.awt.Point;
 import java.util.List;
+
+import org.expeditee.core.Point;
 /**
  * Represents a single mutable search result.
Index: /trunk/src/org/apollo/util/TrackModelLoadManager.java
===================================================================
--- /trunk/src/org/apollo/util/TrackModelLoadManager.java	(revision 1101)
+++ /trunk/src/org/apollo/util/TrackModelLoadManager.java	(revision 1102)
@@ -3,10 +3,8 @@
 import java.io.File;
 import java.io.IOException;
-import java.lang.reflect.InvocationTargetException;
 import java.util.HashSet;
 import java.util.Set;
 
 import javax.sound.sampled.UnsupportedAudioFileException;
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.SampledTrackModel;
@@ -14,4 +12,6 @@
 import org.apollo.io.LoadedAudioData;
 import org.apollo.mvc.Observer;
+import org.expeditee.core.BlockingRunnable;
+import org.expeditee.gio.EcosystemManager;
 import org.expeditee.items.widgets.HeavyDutyInteractiveWidget;
 import org.expeditee.items.widgets.WidgetCacheManager;
@@ -124,8 +124,6 @@
 			
 			try {
-				SwingUtilities.invokeAndWait(locator);
-			} catch (InterruptedException e) {
-				e.printStackTrace();
-			} catch (InvocationTargetException e) {
+				EcosystemManager.getMiscManager().runOnGIOThread(locator);
+			} catch (Exception e) {
 				e.printStackTrace();
 			}
@@ -166,5 +164,5 @@
 	 * Look in expeditee memory - this should be quick - will hold up the user
 	 */
-	private class CachedTrackModelLocator implements Runnable
+	private class CachedTrackModelLocator extends BlockingRunnable
 	{
 		private String localfileName;
@@ -176,5 +174,5 @@
 		}
 		
-		public void run() {
+		public void execute() {
 		
 			// Exploit knowledge that all SampledTrack are Cached HDW
Index: /trunk/src/org/apollo/widgets/AudioConfiguration.java
===================================================================
--- /trunk/src/org/apollo/widgets/AudioConfiguration.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/AudioConfiguration.java	(revision 1102)
@@ -31,11 +31,11 @@
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
-
-public class AudioConfiguration extends InteractiveWidget implements Observer {
+import org.expeditee.items.widgets.SwingWidget;
+
+public class AudioConfiguration extends SwingWidget implements Observer {
 	
 	private static MixerItem[] inputMixerItems = null;
 
-	private JComboBox inputMixureCombo;
+	private JComboBox<MixerItem> inputMixureCombo;
 	private JSlider masterVolumeSlider;
 	private JCheckBox masterMuteCheckBox;
@@ -48,5 +48,5 @@
 		Font descFont = new Font("Arial", Font.PLAIN, 12);
 
-		inputMixureCombo = new JComboBox(getInputMixerItems());
+		inputMixureCombo = new JComboBox<MixerItem>(getInputMixerItems());
 		
 		inputMixureCombo.addActionListener( new ActionListener() {
Index: /trunk/src/org/apollo/widgets/FramePlayer.java
===================================================================
--- /trunk/src/org/apollo/widgets/FramePlayer.java	(revision 1101)
+++ /trunk/src/org/apollo/widgets/FramePlayer.java	(revision 1102)
@@ -1,5 +1,4 @@
 package org.apollo.widgets;
 
-import java.awt.Color;
 import java.awt.Dimension;
 import java.awt.GridBagConstraints;
@@ -21,5 +20,4 @@
 import javax.swing.ComboBoxModel;
 import javax.swing.DefaultComboBoxModel;
-import javax.swing.Icon;
 import javax.swing.JButton;
 import javax.swing.JComboBox;
@@ -45,13 +43,15 @@
 import org.apollo.util.ApolloSystemLog;
 import org.apollo.util.AudioMath;
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.DisplayIOObserver;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.swing.SwingMiscManager;
+import org.expeditee.gui.DisplayController;
+import org.expeditee.gui.DisplayObserver;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.MessageBay;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.Text;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.SwingWidget;
 
 /**
@@ -61,6 +61,6 @@
  *
  */
-public class FramePlayer extends InteractiveWidget 
-	implements Observer, MultitrackLoadListener, ActionListener, DisplayIOObserver {
+public class FramePlayer extends SwingWidget 
+	implements Observer, MultitrackLoadListener, ActionListener, DisplayObserver {
 
 	private static final int BUTTON_SIZE = 40;
@@ -73,5 +73,5 @@
 	private JButton rewindButton;
 	private JButton playLauncherButton;
-	private JComboBox frameSelection;
+	private JComboBox<String> frameSelection;
 	private JToggleButton muteButton;
 	private JSlider volumeSlider;
@@ -86,5 +86,5 @@
 	public static String FRAME_PLAYERMASTER_CHANNEL_ID = "#$frameplayer#master$";
 	
-	private static final Color LOADING_BORDER_COLOR = new Color(22, 205, 5);
+	private static final Colour LOADING_BORDER_COLOR = Colour.FromRGB255(22, 205, 5);
 	//private static final Color FAILED_MESSAGE_COLOR = Color.RED;
 	//private static final Font MESSAGE_FONT = TrackWidgetCommons.FREESPACE_TRACKNAME_FONT;
@@ -180,5 +180,5 @@
 		playPauseButton = new JButton();
 		playPauseButton.addActionListener(this);
-		playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+		SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 		playPauseButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		playPauseButton.setToolTipText("Play selection / Pause");
@@ -187,5 +187,5 @@
 		stopButton.setEnabled(false);
 		stopButton.addActionListener(this);
-		stopButton.setIcon(IconRepository.getIcon("stop.png"));
+		SwingMiscManager.setJButtonIcon(stopButton, IconRepository.getIcon("stop.png"));
 		stopButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		stopButton.setToolTipText("Stop playback");
@@ -193,5 +193,5 @@
 		rewindButton = new JButton();
 		rewindButton.addActionListener(this);
-		rewindButton.setIcon(IconRepository.getIcon("rewind.png"));
+		SwingMiscManager.setJButtonIcon(rewindButton, IconRepository.getIcon("rewind.png"));
 		rewindButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		rewindButton.setToolTipText("Rewind to start");
@@ -199,5 +199,5 @@
 		// Icon changes
 		muteButton = new JToggleButton();
-		muteButton.setSelectedIcon(IconRepository.getIcon("volmute.png"));
+		SwingMiscManager.setJButtonIcon(muteButton, IconRepository.getIcon("volmute.png"));
 		muteButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		muteButton.setToolTipText("Toggle mute");
@@ -212,5 +212,5 @@
 		playLauncherButton = new JButton();
 		playLauncherButton.addActionListener(this);
-		playLauncherButton.setIcon(IconRepository.getIcon("frameplay.png"));
+		SwingMiscManager.setJButtonIcon(playLauncherButton, IconRepository.getIcon("frameplay.png"));
 		playLauncherButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		playLauncherButton.setToolTipText("Play from a specific position");
@@ -231,5 +231,5 @@
 		volumeSlider.setPreferredSize(new Dimension((3 * BUTTON_SIZE) - (2 * VOLUME_SPACING), BUTTON_SIZE));
 
-		frameSelection = new JComboBox();
+		frameSelection = new JComboBox<String>();
 		frameSelection.setEditable(true);
 		frameSelection.setPreferredSize(new Dimension(4 * BUTTON_SIZE, BUTTON_SIZE));
@@ -304,5 +304,5 @@
 			stopButton.setEnabled(false);
 			playPauseButton.setEnabled(true);
-			playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+			SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 			playLauncherButton.setEnabled(true);
 
@@ -323,5 +323,5 @@
 			playLauncherButton.setEnabled(true);
 			playPauseButton.setEnabled(true);
-			playPauseButton.setIcon(IconRepository.getIcon("pause.png"));
+			SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("pause.png"));
 
 			setWidgetEdgeThickness(TrackWidgetCommons.PLAYING_TRACK_EDGE_THICKNESS);
@@ -336,5 +336,5 @@
 		
 		invalidateSelf();
-		FrameGraphics.refresh(true);
+		DisplayController.requestRefresh(true);
 	}
 	
@@ -361,5 +361,5 @@
 			MultiTrackPlaybackController.getInstance().addObserver(this); // the core!
 			masterMix.addObserver(this);
-			DisplayIO.addDisplayIOObserver(this);
+			DisplayController.addDisplayObserver(this);
 		
 			// Evaluate the state of this add set the state accordingly
@@ -405,5 +405,5 @@
 			
 			// Remove observers
-			DisplayIO.removeDisplayIOObserver(this);
+			DisplayController.removeDisplayObserver(this);
 			SoundDesk.getInstance().removeObserver(this);
 			MultiTrackPlaybackController.getInstance().removeObserver(this);
@@ -544,10 +544,10 @@
 		if ((frameSelection.getSelectedItem() != null && frameSelection.getSelectedItem().equals(CURRENT_FRAME_SPECIFIER))
 				|| frameSelection.getSelectedItem() == null)
-			return DisplayIO.getCurrentFrame().getName();
+			return DisplayController.getCurrentFrame().getName();
 		
 		String frameSpecifier = (String)frameSelection.getSelectedItem();
 		
 		if (frameSpecifier.isEmpty()) {
-			return DisplayIO.getCurrentFrame().getName();
+			return DisplayController.getCurrentFrame().getName();
 		}
 		
@@ -671,12 +671,12 @@
 			
 			String target = getSelectedFrameName();
-			if (target == DisplayIO.getCurrentFrame().getName()) target = null;
+			if (target == DisplayController.getCurrentFrame().getName()) target = null;
 			
 			// Create the launcher
 			FramePlaybackLauncher launcher = new FramePlaybackLauncher(target);
-			launcher.setPosition(FrameMouseActions.MouseX, FrameMouseActions.MouseY);
+			launcher.setPosition(DisplayController.getMousePosition());
 
 			// Pick it up
-			FrameMouseActions.pickup(launcher);
+			StandardGestureActions.pickup(launcher);
 		}
 		
@@ -687,6 +687,6 @@
 		
 		// Get border color currently used
-		Color oldC = getSource().getBorderColor();
-		Color newC = null;
+		Colour oldC = getSource().getBorderColor();
+		Colour newC = null;
 		
 		if (this.state == PLAYBACK_LOADING) {
@@ -714,5 +714,5 @@
 	private void updateButtonGUI() {
 		
-		Icon newIcon = null;
+		Image newIcon = null;
 		if (volumeSlider.getValue() <= 25) 
 				newIcon = IconRepository.getIcon("vol25.png");
@@ -724,5 +724,5 @@
 				newIcon = IconRepository.getIcon("vol100.png");
 		
-		muteButton.setIcon(newIcon);
+		SwingMiscManager.setJButtonIcon(muteButton, newIcon);
 	}
 	
@@ -783,5 +783,5 @@
 		
 		// Place last visited frames
-		List<String> history = DisplayIO.getUnmodifiableVisitedList();
+		List<String> history = DisplayController.getUnmodifiableVisitedList();
 		
 		for (int i = history.size() - 1; i >= 0; i--) {
@@ -802,5 +802,5 @@
 		}
 		
-	    ComboBoxModel model = new DefaultComboBoxModel(orderedModelData.toArray());
+	    ComboBoxModel<String> model = new DefaultComboBoxModel<String>((String[]) orderedModelData.toArray());
 	    
 	    // Remove helper tags from model data
